library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
entity divider is
port (
num, den: in std_logic_vector(N-1 downto 0);
clk, reset, start: in std_logic;
done: out std_logic;
z: out std_logic_vector(N-1 downto 0)
);
end divider;

architecture circuit of divider is

component data_path
port (
num, den: in std_logic_vector(n-1 downto 0);
clk, reset: in std_logic; 
first_step, oper_a, msb_a, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p: in std_logic;
cont_u: in std_logic_vector(1 downto 0);
cont_d: in std_logic;
z: out std_logic_vector(n-1 downto 0);
p_gt_0, d_equ_0, sign_d, a_0, u_0, u_plus_v: out std_logic
);
end component;

component control
port (
clk, reset,start: in std_logic;
first_step, oper_a, msb_a, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p: out std_logic;
cont_u: out std_logic_vector(1 downto 0);
cont_d: out std_logic;
p_gt_0, d_equ_0, sign_d, a_0, u_0, u_plus_v: in std_logic;
done: out std_logic);
end component;

signal first_step, oper_a, msb_a, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p: std_logic;
signal cont_u: std_logic_vector(1 downto 0);
signal cont_d: std_logic;
signal p_gt_0, d_equ_0, sign_d, a_0, u_0, u_plus_v: std_logic;

begin

data_path_block: data_path port map (num, den, clk, reset, first_step, 
oper_a, msb_a, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p, 
cont_u, cont_d, z, p_gt_0, d_equ_0, sign_d, a_0, u_0, u_plus_v);

control_unit: control port map (clk, reset,start, first_step, oper_a, 
msb_a, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p, 
cont_u, cont_d, p_gt_0, d_equ_0, sign_d, a_0, u_0, u_plus_v, done);

end circuit;