library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
entity UV_cell is
port (
u, v, num: in STD_LOGIC_VECTOR (N-1 downto 0);
cont_u: in std_logic_vector(1 downto 0);
first_step: in std_logic;
new_u, new_v: out STD_LOGIC_VECTOR (N-1 downto 0)
);
end UV_cell;

architecture rtl of UV_cell is
signal sum_1: STD_LOGIC_VECTOR (N-2 downto 0);
signal sum_2: STD_LOGIC_VECTOR (N-1 downto 0);
begin

first_adder: for i in 0 to n-2 generate
sum_1(i) <= u(i+1) xor (cont_u(0) and v(i+1));
end generate;

second_adder: for i in 0 to n-2 generate
sum_2(i) <= sum_1(i) xor (cont_u(1) and f(i+1));
end generate;
sum_2(n-1) <= cont_u(1);

with first_step select new_u <= sum_2 when '0', num when others;

with first_step select new_v <= u when '0', (others => '0') when others;

end rtl;
